#define GL_GLEXT_PROTOTYPES 1

#include <GL/glut.h>
#include <math.h>

#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>

#include "laby.h"
#include "texture.h"

char demo = 0;
char invert = 0;
float wall_border = 0.03;
static float smoothness = 10;
static float zahled = 0.4;
static float perspective = 25;
static char debugrot = 0;
static char max_visibility = 10;
static int X=0, Y=0, Z=0;
static float fX=0, fY=0, fZ=0;
static double speed = 0.8, rspeed = 1.2;
static int lX=0,lY=1,lZ=0;
static double flX=0,flY=1,flZ=0;
static int kX=0,kY=0,kZ=1;
static double fkX=0,fkY=0,fkZ=1;
static int timerInterval=200;              // interval of timer in miliseconds
static int w_width, w_height;
static int sc_width, sc_height;
static char space;
static char change=1;
static GLfloat fogcolor[4] = {0.0, 0.0, 0.0, 1.0};

void moveone();
void demogo();

void drawstr(float x, float y, char* format, ...)
{
    va_list args;
    char buffer[255], *s;
    
    va_start(args, format);
    vsprintf(buffer, format, args);
    va_end(args);
    
    //glWindowPos2i(x, y);
    for (s = buffer; *s; s++)
      glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_24, *s);
}

void turnstep()
{
  double uX,uY,uZ, vX,vY,vZ, wX,wY,wZ,tX,tY,tZ, w;
  double c,c1,s, uhel, d1, d2;
  double epsilon =0.0001;
  char  merl;

  if(lX == flX && lY == flY && lZ == flZ && kX == fkX && kY == fkY && kZ == fkZ) return;

  change = 1;

  if(debugrot){
    printf("\nStart\n\n");
    printf("\n");
    printf("(%f, %f, %f), (%f, %f, %f) ==> (%d, %d, %d), (%d, %d, %d)",
	   flX,flY,flZ,fkX,fkY,fkZ,lX,lY,lZ,kX,kY,kZ);
  }

  if(fabs(lX-flX) <= epsilon &&
     fabs(lY-flY) <= epsilon &&
     fabs(lZ-flZ) <= epsilon &&
     fabs(kX-fkX) <= epsilon &&
     fabs(kY-fkY) <= epsilon &&
     fabs(kZ-fkZ) <= epsilon){
    if(debugrot) printf("zaokrouhluji\n");
    flX=lX;
    flY=lY;
    flZ=lZ;
    fkX=kX;
    fkY=kY;
    fkZ=kZ;
    return;
  }

  uX = flX-lX; uY = flY-lY; uZ = flZ-lZ;
  vX = fkX-kX; vY = fkY-kY; vZ = fkZ-kZ;  
  if(debugrot) printf("w = (%f, %f, %f)x(%f, %f, %f)\n",
		      uX, uY, uZ, vX, vY, vZ);
  wX = uY*vZ-uZ*vY; wY = uZ*vX-uX*vZ;  wZ = uX*vY-uY*vX;
  w = sqrt(wX*wX+wY*wY+wZ*wZ);
  if(w <= epsilon){
    if(debugrot) printf("EXCEPTION 1\n");
    uX = flY*fkZ-flZ*fkY; uY = flZ*fkX-flX*fkZ;  uZ = flX*fkY-flY*fkX;
    vX = lY*kZ-lZ*kY; vY = lZ*kX-lX*kZ;  vZ = lX*kY-lY*kX;
    if(debugrot) printf("w = (%f, %f, %f)x(%f, %f, %f)\n", uX, uY, uZ,
			vX, vY, vZ);
    wX = uY*vZ-uZ*vY; wY = uZ*vX-uX*vZ;  wZ = uX*vY-uY*vX;
    w = sqrt(wX*wX+wY*wY+wZ*wZ);
    if(w <= epsilon){
      if(lX*flX + lY*flY + lZ*flZ > kX*fkX + kY*fkY + kZ*fkZ){
	if(debugrot) printf("EXCEPTION 2.1: %f > %f\n",
			    lX*flX + lY*flY + lZ*flZ, kX*fkX + kY*fkY + kZ*fkZ);
	wX = flX+lX; wY = flY+lY; wZ = flZ+lZ; 
      }
      else{
	if(debugrot) printf("EXCEPTION 2.2: %f <= %f\n",
			    lX*flX + lY*flY + lZ*flZ, kX*fkX + kY*fkY + kZ*fkZ);
	wX = fkX+kX; wY = fkY+kY; wZ = fkZ+kZ;
      }
      w = sqrt(wX*wX+wY*wY+wZ*wZ);
    }
  }
  if(w <= epsilon){
    warning("Unable to find the axis of rotation: (%f,%f,%f),(%f,%f,%f) ===> (%d,%d,%d),(%d,%d,%d)",
	    flX,flY,flZ, fkX,fkY,fkZ, lX,lY,lZ, kX,kY,kZ);
    flX = lX; flY = lY; flZ = lZ;
    fkX = kX; fkY=kY;  fkZ = kZ;
    return;
  }

  if(debugrot) printf("\nw = (%f, %f, %f)\n", wX, wY, wZ);
  wX /= w;
  wY /= w;
  wZ /= w;
  if(debugrot) printf("normalize w: (%f, %f, %f)\n\n", wX, wY, wZ);

  if(debugrot) printf("(%f, %f, %f)\n", wX, wY, wZ);

  
  if(fabs(wX*lX+wY*lY+wZ*lZ) <= fabs(wX*kX+wY*kY+wZ*kZ)) merl = 1;
  else merl = 0;

  if(merl) d1 = wX*lY*flZ+wY*lZ*flX+wZ*lX*flY-wX*lZ*flY-wY*lX*flZ-wZ*lY*flX;
  else d1 = wX*kY*fkZ+wY*kZ*fkX+wZ*kX*fkY-wX*kZ*fkY-wY*kX*fkZ-wZ*kY*fkX;

  if(d1>0) uhel = -rspeed/smoothness;
  else uhel = rspeed/smoothness;

  c = cos(uhel);
  c1 = 1-c;
  s = sin(uhel);

  uX = flX*(wX*wX*c1+c)    + flY*(wX*wY*c1-wZ*s) + flZ*(wX*wZ*c1+wY*s);
  uY = flX*(wX*wY*c1+wZ*s) + flY*(wY*wY*c1+c)    + flZ*(wY*wZ*c1-wX*s);
  uZ = flX*(wX*wZ*c1-wY*s) + flY*(wY*wZ*c1+wX*s) + flZ*(wZ*wZ*c1+c);

  vX = fkX*(wX*wX*c1+c)    + fkY*(wX*wY*c1-wZ*s) + fkZ*(wX*wZ*c1+wY*s);
  vY = fkX*(wX*wY*c1+wZ*s) + fkY*(wY*wY*c1+c)    + fkZ*(wY*wZ*c1-wX*s);
  vZ = fkX*(wX*wZ*c1-wY*s) + fkY*(wY*wZ*c1+wX*s) + fkZ*(wZ*wZ*c1+c);

  w = sqrt(uX*uX+uY*uY+uZ*uZ);
  if(!w){
    warning("U is zero vector");
    uX = lX; uY = lY; uZ = lZ;
  }
  else if(w != 1){
    if(debugrot) printf("normalize: %f\n", w);
    uX/=w; uY/=w; uZ/=w;
  }

  if(uX*vX+uY*vY+uZ*vZ != 0){
    if(debugrot) printf("orthogonalize: U*V = %f, (%f, %f, %f)\n", uX*vX+uY*vY+uZ*vZ, vX,vY,vZ);
    tX = uY*vZ-uZ*vY; tY = uZ*vX-uX*vZ; tZ = uX*vY-uY*vX;
    vX = tY*uZ-tZ*uY; vY = tZ*uX-tX*uZ; vZ = tX*uY-tY*uX;
    if(debugrot) printf("orthogonalized: U*V = %f, (%f, %f, %f)\n",
      uX*vX+uY*vY+uZ*vZ, vX,vY,vZ);
  }

  w = sqrt(vX*vX+vY*vY+vZ*vZ);
  if(!w){
    warning("V is zero vector");
    vX = kX; vY = kY; vZ = kZ;
  }
  else if(w != 1){
    if(debugrot) printf("normalize: %f\n", w);
    vX/=w; vY/=w; vZ/=w;
  }

  if(d1){
    if(merl) d2 = wX*lY*uZ+wY*lZ*uX+wZ*lX*uY-wX*lZ*uY-wY*lX*uZ-wZ*lY*uX;
    else d2 = wX*kY*vZ+wY*kZ*vX+wZ*kX*vY-wX*kZ*vY-wY*kX*vZ-wZ*kY*vX;
    if(debugrot) printf("d1=%f, d2=%f\n", d1, d2);
    if((d1 < 0 && d2 > 0) || (d1 > 0 && d2 < 0)){
      if(debugrot){
	printf("overwind, I finish\n");
	printf("fl = (%f, %f, %f)\n", flX, flY, flZ);
	printf("l = (%d, %d, %d)\n", lX, lY, lZ);
	printf("kl = (%f, %f, %f)\n", fkX, fkY, fkZ);
	printf("k = (%d, %d, %d)\n", kX, kY, kZ);
	if(merl) printf("following L\n");
	else printf("following K\n");
	printf("u = (%f, %f, %f)\n", uX, uY, uZ);
	printf("v = (%f, %f, %f)\n", vX, vY, vZ);
      }
      flX = lX; flY=lY;  flZ = lZ;
      fkX = kX; fkY=kY;  fkZ = kZ;
      return;
    }
  }

  flX=uX; flY=uY; flZ=uZ;
  fkX=vX; fkY=vY; fkZ=vZ;
}

void onTimer(int value)
{
  float *fxyz = NULL;

  glutTimerFunc(timerInterval/smoothness, onTimer, value); // next timer

  if(fX) fxyz = &fX;
  if(fY) fxyz = &fY;
  if(fZ) fxyz = &fZ;
  if(fxyz){
    if(fabsf(*fxyz) < speed/smoothness) *fxyz = 0;
    else *fxyz -= speed/smoothness*(*fxyz/fabsf(*fxyz));
    change = 1;
  }

  if(demo) demogo();
  if(space) moveone();

  turnstep();
  if(change) glutPostRedisplay();            // redraw scene
}

void loadlook()
{
  glLoadIdentity();
  gluLookAt(fX+X-zahled*flX, fY+Y-zahled*flY, fZ+Z-zahled*flZ, 
	    fX+X+(1-zahled)*flX, fY+Y+(1-zahled)*flY, fZ+Z+(1-zahled)*flZ,
	    fkX, fkY, fkZ);
}


void changeSize(int w, int h)
{
  w_width = w;
  w_height = h;

  // Prevent a divide by zero, when window is too short
  // (you cant make a window of zero width).
  if(h == 0) h = 1;
  if(w == 0) w = 1;

  // Reset the coordinate system before modifying
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
	
  // Set the viewport to be the entire window
  glViewport(0, 0, w, h);

  // Set the clipping volume
  glScalef(sqrt((float)h/w)/4, sqrt((float)w/h)/4, 1);
  if(zahled > 0) gluPerspective(perspective,1,zahled,max_visibility);
  else gluPerspective(perspective,1,0.001,max_visibility);
  glMatrixMode(GL_MODELVIEW);
}

void initScene()
{
  glEnable(GL_DEPTH_TEST);
  glEnable(GL_BLEND);
  glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
  glEnable(GL_FOG);
  glFogfv(GL_FOG_COLOR, fogcolor);
  glFogf(GL_FOG_DENSITY, 0.4);
  glFogi(GL_FOG_MODE, GL_EXP);
}

char aktudir(int x, int y, int z)
{
  if(x) return (1-x)/2;
  if(y) return (1-y)/2+2;
  if(z) return (1-z)/2+4;

  warning("unable to set the direction");
  return -1;
}

static float dircolor(int dir)
{
  float front = 0.8;
  float side = 0.7;
  float top = 0.6;

  switch(dir/2){
  case 0: return side + (front-side)*flX*flX + (top-side)*fkX*fkX;
  case 1: return side + (front-side)*flY*flY + (top-side)*fkY*fkY;
  case 2: return side + (front-side)*flZ*flZ + (top-side)*fkZ*fkZ;
  }

  warning("unknovn direction");
  return 0;
}

void renderScene(void)
{
  int x, y, z, dx, dy, dz, i;
  int startx, starty, startz, endx, endy, endz, aktux, aktuy, aktuz;
  float color, acolor;
  char flip;

  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  loadlook();
  glBindTexture(GL_TEXTURE_2D, emptytex);  

  aktux = floor(fX+X-zahled*flX+0.5);
  aktuy = floor(fY+Y-zahled*flY+0.5);
  aktuz = floor(fZ+Z-zahled*flZ+0.5);

  startx = aktux-1-max_visibility;
  starty = aktuy-1-max_visibility;
  startz = aktuz-1-max_visibility;
  if(startx < 0) startx = 0;
  if(starty < 0) starty = 0;
  if(startz < 0) startz = 0;
  endx = aktux-1+max_visibility;
  endy = aktuy-1+max_visibility;
  endz = aktuz-1+max_visibility;
  if(endx > width) endx = width;
  if(endy > height) endy = height;
  if(endz > depth) endz = depth;

  if(startx > endx || starty > endy || startz > endz) return;

  glPushMatrix();
  if(startx || starty || startz) glTranslatef(startx, starty, startz);

  /* ======================= Z walls ================== */

  color = dircolor(BACKWARD);
  glColor3f(color, color, color);

  glPushMatrix();
  glTranslatef(1, 1, 0.5);
  if(startz<=aktuz){
    glTranslatef(0,0, wall_border);
    flip = 1;
  }
  else{
    glTranslatef(0,0, -wall_border);
    flip = 0;
  }
  for(z=startz; z<=endz; z++){
    if(z==aktuz){
      glTranslatef(0,0, -2*wall_border);
      flip = 0;
    }

    glPushMatrix();
    for(y=starty; y<=endy; y++) {
      glRectf(-0.5-wall_border, -0.5-wall_border, endx-startx-0.5+wall_border, -0.5+wall_border);
      glTranslatef(0, 1, 0);
    }
    glPopMatrix();

    glPushMatrix();
    for(x=startx; x<=endx; x++) {
      glRectf(-0.5-wall_border, -0.5-wall_border, -0.5+wall_border, endy-starty-0.5+wall_border);
      glTranslatef(1, 0, 0);
    }
    glPopMatrix();

    glPushMatrix();
    for(y=starty; y<endy; y++){
      glPushMatrix();
      for(x=startx; x<endx; x++){
	drawsquare(x,y,z,BACKWARD, flip);
	glTranslatef(1, 0, 0);
      }
      glPopMatrix();
      glTranslatef(0, 1, 0);
    }
    glPopMatrix();
    glTranslatef(0, 0, 1);
  }
  glPopMatrix();

  /* ======================= Y walls ================== */

  color = dircolor(UP);
  glColor3f(color, color, color);

  glPushMatrix();
  glRotatef(90, 1,0,0);
  glTranslatef(1, 1, -0.5);
  if(starty<=aktuy){
    glTranslatef(0,0, -wall_border);
    flip = 0;
  }
  else{
    glTranslatef(0,0, wall_border);
    flip = 1;
  }
  for(y=starty; y<=endy; y++){
    if(y==aktuy){
      glTranslatef(0,0, 2*wall_border);
      flip = 1;
    }

    glPushMatrix();
    for(z=startz; z<=endz; z++) {
      glRectf(-0.5-wall_border, -0.5-wall_border, endx-startx-0.5+wall_border, -0.5+wall_border);
      glTranslatef(0, 1, 0);
    }
    glPopMatrix();

    glPushMatrix();
    for(x=startx; x<=endx; x++){
      glRectf(-0.5-wall_border, -0.5-wall_border, -0.5+wall_border, endz-startz-0.5+wall_border);
      glTranslatef(1, 0, 0);
    }
    glPopMatrix();

    glPushMatrix();
    for(z=startz; z<endz; z++){
      glPushMatrix();
      for(x=startx; x<endx; x++){
	drawsquare(x,y,z,UP,flip);
	glTranslatef(1, 0, 0);
      }
      glPopMatrix();
      glTranslatef(0, 1, 0);
    }
    glPopMatrix();
    glTranslatef(0, 0, -1);
  }
  glPopMatrix();

  /* ======================= X walls ================== */

  color = dircolor(LEFT);
  glColor3f(color, color, color);

  glPushMatrix();
  glRotatef(-90, 0,1,0);
  glTranslatef(1, 1, -0.5);
  if(startx<=aktux){
    glTranslatef(0,0, -wall_border);
    flip = 0;
  }
  else{
    glTranslatef(0,0, wall_border);
    flip = 1;
  }
  for(x=startx; x<=endx; x++){
    if(x==aktux){
      glTranslatef(0,0, 2*wall_border);
      flip = 1;
    }

    glPushMatrix();
    for(y=starty; y<=endy; y++) {
      glRectf(-0.5-wall_border, -0.5-wall_border, endz-startz-0.5+wall_border, -0.5+wall_border);
      glTranslatef(0, 1, 0);
    }
    glPopMatrix();

    glPushMatrix();
    for(z=startz; z<=endz; z++){
      glRectf(-0.5-wall_border, -0.5-wall_border, -0.5+wall_border, endy-starty-0.5+wall_border);
      glTranslatef(1, 0, 0);
    }
    glPopMatrix();

    glPushMatrix();
    for(y=starty; y<endy; y++){
      glPushMatrix();
      for(z=startz; z<endz; z++){
	drawsquare(x,y,z,LEFT,flip);
	glTranslatef(1, 0, 0);
      }
      glPopMatrix();
      glTranslatef(0, 1, 0);
    }
    glPopMatrix();
    glTranslatef(0, 0, -1);
  }
  glPopMatrix();
  glPopMatrix();

  /* ======================= start, finish ================== */

  for(i=0; i<3; i++){
    acolor = 1;
    if(fX || fY || fZ){
      dx=dy=dz=0;
      if(fX) dx = fX/fabs(fX);
      if(fY) dy = fY/fabs(fY);
      if(fZ) dz = fZ/fabs(fZ);
      x = X-1; y = Y-1; z = Z-1;
      if((x == SCX[i%2] && y == SCY[i%2] && z == SCZ[i%2] &&
	  SCside[i%2] == backdir(aktudir(dx,dy,dz))) ||
	 (x+dx == SCX[i%2] && y+dy == SCY[i%2] && z+dz == SCZ[i%2] &&
	  SCside[i%2] == aktudir(dx,dy,dz)))
	acolor = fabs(fabs(fX+fY+fZ)-0.5);
    }
    if(i == 0 && acolor != 1) continue;
    if(i == 2 && acolor == 1) break;

    color = dircolor(SCside[i%2]);
    glPushMatrix();
    glTranslatef(SCX[i%2]+1, SCY[i%2]+1, SCZ[i%2]+1);
    glColor4f(0, color*(i%2), color*(1-i%2), acolor);
    x=y=z=0;
    movecoor(&x, &y, &z, backdir(SCside[i%2]));
    if(z){
      if(z > 0) glTranslatef(0,0,0.5);
      else glTranslatef(0,0,-0.5);
    }
    else{
      glRotatef(90, -y,x,0);
      glTranslatef(0,0,0.5);
    }
    texturect(SCtex, 0, 0);
    glPopMatrix();
  }

  glutSwapBuffers();
  change = 0;
}

void demorient()
{
  int lx, ly, lz, dir;

  dir = demomove(X-1, Y-1, Z-1);
  if(dir < 0){
    demo = 0;
    return;
  }

  lx = ly = lz = 0;
  movecoor(&lx, &ly, &lz, dir);

  if(lx*kX + ly*kY + lz*kZ){
    if(lx == kX && ly == kY && lz == kZ){
      kX = -lX; kY = -lY; kZ = -lZ;
    }
    else{
      kX = lX; kY = lY; kZ = lZ;
    }
  }
  lX = lx; lY = ly; lZ = lz;
}

void demogo()
{
  if(fX || fY || fZ) return;

  if(demo == 2){
    demorient();
    if(demo) demo = 1;
  }

  X += lX;
  fX =-lX;
  Y += lY;
  fY =-lY;
  Z += lZ;
  fZ =-lZ;

  demorient();
}

void orientMe(char lr, char backne)
{
  int px, py, pz;

  if(demo) return;

  if(invert && !lr) backne = !backne;

  px = lX;
  py = lY;
  pz = lZ;

  if(lr){
    lX = py*kZ-pz*kY;
    lY = pz*kX-px*kZ;
    lZ = px*kY-py*kX;
  }
  else{
    lX = kX; lY = kY; lZ = kZ;
    if(backne){ kX = px; kY = py; kZ = pz; }
    else      { kX =-px; kY =-py; kZ =-pz; }

  }
  if(backne){ lX *=-1; lY*= -1; lZ *= -1; }
}

void moveone()
{
  if(demo) return;

  if(fX || fY || fZ) return;
  if(!analyzetah(X-1, Y-1, Z-1, aktudir(lX,lY,lZ))) return;

  X += lX;
  fX =-lX;
  Y += lY;
  fY =-lY;
  Z += lZ;
  fZ =-lZ;
}

int fwidth, fheight, fullX, fullY;

void processNormalKeys(unsigned char key, int x, int y)
{
  key=(key>'A' && key<='Z') ? key+'a'-'A':key; // prevod na mala pismena

  switch(key){
  case 27: exit(0);
  case 'i': invert = !invert; break;
  case 'f':
    if(w_width == sc_width && w_height == sc_height){
      glutPositionWindow(fullX, fullY);
      glutReshapeWindow(fwidth, fheight);
      glutPostRedisplay();
    }
    else{
      fullX = glutGet(GLUT_WINDOW_X);
      fullY = glutGet(GLUT_WINDOW_Y);
      fwidth = w_width;
      fheight = w_height;
      glutFullScreen();
      glutPositionWindow(0, 0);
    }
    break;
  case ' ': moveone(); space = 1; break;
  }
}

void releaseKey(unsigned char key, int x, int y)
{
  if(key == ' ') space = 0;
}

void inputKey(int key, int x, int y)
{
  switch (key) {
  case GLUT_KEY_LEFT:  orientMe(1,1);break;
  case GLUT_KEY_RIGHT: orientMe(1,0);break;
  case GLUT_KEY_UP:    orientMe(0,0); break;
  case GLUT_KEY_DOWN:  orientMe(0,1); break;
  }
}


int main(int argc, char **argv)
{
  char fstart;

  fstart = 0;
  setlaby(argc, argv, &fstart);
  createlaby();
  analyzelaby();

  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGBA);
  glutInitWindowSize(640,480);
  glutCreateWindow("Labyrint 3D");

  initScene();
  inittex();
  putimages();

  glutKeyboardFunc(processNormalKeys);
  glutKeyboardUpFunc(releaseKey);
  glutSpecialFunc(inputKey);

  glutDisplayFunc(renderScene);
  glutTimerFunc(timerInterval/smoothness, onTimer, 1234);
  glutReshapeFunc(changeSize);

  if(fstart){
    fullX = 50;
    fullY = 50;
    fwidth = 640;
    fheight = 480;
    glutFullScreen();
    glutPositionWindow(0, 0);
  }

  sc_width = glutGet(GLUT_SCREEN_WIDTH);
  sc_height = glutGet(GLUT_SCREEN_HEIGHT);

  glutMainLoop();

  return(0);
}
